package com.virtual.plat.server.virtualhost;

import com.extjs.gxt.ui.client.data.ModelData;
import com.virtual.common.AppException;
import com.virtual.common.FuncUtil;
import com.virtual.common.StringManager;
import com.virtual.plat.server.common.CommonMgr;
import com.virtual.plat.server.controller.entity.DomainStatusCount;
import com.virtual.plat.server.controller.entity.RpProfilePo;
import com.virtual.plat.server.entity.Domain;
import com.virtual.plat.server.entity.Host;
import com.virtual.plat.server.entity.LicenseInfo;
import com.virtual.plat.server.entity.PublicCloud;
import com.virtual.plat.server.entity.QueryConfig;
import com.virtual.plat.server.entity.QueryResult;
import com.virtual.plat.server.entity.ResourcePool;
import com.virtual.plat.server.entity.RpNet;
import com.virtual.plat.server.entity.User;
import com.virtual.plat.server.entity.UserVm;
import com.virtual.plat.server.entity.VmWorkflow;
import com.virtual.plat.server.host.HostMgr;
import com.virtual.plat.server.http.pool.HttpConnectionManager;
import com.virtual.plat.server.license.LicenseManager;
import com.virtual.plat.server.mail.MailSenderMgr;
import com.virtual.plat.server.network.NetworkHandler;
import com.virtual.plat.server.organize.OrgParamertersHandler;
import com.virtual.plat.server.organize.OrganizationMgr;
import com.virtual.plat.server.organize.OrganizationUtils;
import com.virtual.plat.server.publiccloud.PublicCloudMgr;
import com.virtual.plat.server.resourcepool.ResourcePoolHandler;
import com.virtual.plat.server.resourcepool.ResourcePoolMgr;
import com.virtual.plat.server.resourcepool.ResourcePoolUtils;
import com.virtual.plat.server.rs.client.RsClientUtils;
import com.virtual.plat.server.rs.vm.entity.RsDomain;
import com.virtual.plat.server.rs.vm.entity.RsDomainDetail;
import com.virtual.plat.server.rs.vm.entity.RsDomainForModify;
import com.virtual.plat.server.rs.vm.entity.RsDomainForModify.CpuConfig;
import com.virtual.plat.server.rs.vm.entity.RsDomainForModify.StorageConfig;
import com.virtual.plat.server.sms.SmsMgr;
import com.virtual.plat.server.template.TemplateHandler;
import com.virtual.plat.server.virtualdesktoppool.VirDesktopPoolMgr;
import com.virtual.plat.server.virtualhost.DomainHandler;
import com.virtual.plat.server.virtualhost.DomainMgr;
import com.virtual.plat.server.vmworkflow.VmWorkflowMgr;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class DomainUtils {

   private static Log a = LogFactory.getLog(DomainUtils.class);
   private static StringManager b = StringManager.getManager(DomainUtils.class);


   public static void checkVmLicense(Long var0, CommonMgr var1) {
      LicenseInfo var2;
      if((var2 = LicenseManager.getLicense()) != null && var2.isControlVM() && var2.getVmNum().intValue() >= 0 && getUsedVmNum(var0, var1) >= var2.getVmNum().intValue()) {
         throw new AppException(1136);
      }
   }

   public static int getUsedVmNum(Long var0, CommonMgr var1) {
      int var2 = 0;
      StringBuilder var3;
      (var3 = new StringBuilder()).append("SELECT COUNT(DISTINCT DOMAIN_ID) FROM TBL_USER_VM");
      if(var0 != null) {
         var3.append(" WHERE DOMAIN_ID<>");
         var3.append(var0);
      }

      List var4;
      if(!(var4 = var1.queryBySql(var3.toString())).isEmpty()) {
         var2 = FuncUtil.getIntegerValue(var4.get(0)).intValue();
      }

      return var2;
   }

   public static int getUserNum(CommonMgr var0) {
      int var1 = 0;
      StringBuilder var2;
      (var2 = new StringBuilder()).append("SELECT COUNT(ID) FROM TBL_USER");
      List var3;
      if(!(var3 = var0.queryBySql(var2.toString())).isEmpty()) {
         var1 = FuncUtil.getIntegerValue(var3.get(0)).intValue();
      }

      return var1;
   }

   public static void delDomainRela(Long var0, CommonMgr var1) {
      StringBuilder var2;
      (var2 = new StringBuilder()).append("DELETE FROM TBL_USER_VM WHERE DOMAIN_ID = ").append(var0);
      var1.execUpdate(var2.toString());
   }

   public static void delDomain(Long var0, CommonMgr var1) {
      StringBuilder var2;
      (var2 = new StringBuilder()).append("DELETE FROM TBL_DOMAIN WHERE ID = ").append(var0);
      var1.execUpdate(var2.toString());
   }

   public static void delStrategyVM(Long var0, CommonMgr var1) {
      StringBuilder var2;
      (var2 = new StringBuilder()).append("DELETE  FROM TBL_CLOUD_BACKUP_VM ");
      var2.append(" WHERE DOMAIN_ID = ");
      var2.append(var0);
      var1.execUpdate(var2.toString());
   }

   public static boolean isOnlyQcow2Storage(List var0) {
      Iterator var2 = var0.iterator();

      StorageConfig var1;
      do {
         if(!var2.hasNext()) {
            return true;
         }

         var1 = (StorageConfig)var2.next();
      } while(!"disk".equals(var1.getDevice()) && !"lun".equals(var1.getDevice()) || "qcow2".equals(var1.getFormat()));

      return false;
   }

   public static void checkDeployVmByTemp(ModelData var0, OrganizationMgr var1, VirDesktopPoolMgr var2) {
      Long var3 = (Long)var0.get("orgId");
      Long var6 = (Long)var0.get("desktopPoolId");
      if(var3 != null && !var3.equals("")) {
         Integer var4 = var1.queryOrgById(var3).getMaxVmNum();
         String var9 = "SELECT COUNT( DISTINCT DOMAIN_ID) FROM TBL_USER_VM WHERE ORG_ID = " + var3;
         List var10 = var1.queryInfoBySql(var9);
         int var5 = 0;
         if(var10 != null && var10.size() > 0) {
            var5 = FuncUtil.getIntegerValue(var10.get(0)).intValue();
         }

         if(var5 >= var4.intValue()) {
            Object[] var8 = new Object[]{var4};
            throw new AppException(1507, var8);
         }

         if(var6 != null) {
            var4 = var2.queryDesktopPoolById(var6).getMaxVmNum();
            var9 = "SELECT COUNT( DISTINCT DOMAIN_ID) FROM TBL_USER_VM WHERE DESKTOP_POOL_ID = " + var6;
            if((var10 = var1.queryInfoBySql(var9)) != null && var10.size() > 0) {
               var5 = FuncUtil.getIntegerValue(var10.get(0)).intValue();
            }

            if(var5 >= var4.intValue()) {
               Object[] var7 = new Object[]{var4};
               throw new AppException(14050, var7);
            }
         }
      }

   }

   public static void checkDeployVmWithoutTemp(ModelData var0, OrganizationMgr var1, VirDesktopPoolMgr var2, PublicCloudMgr var3, NetworkHandler var4, ResourcePoolMgr var5, DomainHandler var6, ResourcePoolHandler var7) {
      QueryConfig var19 = new QueryConfig();
      Long var8 = (Long)var0.get("orgId");
      Long var9 = (Long)var0.get("desktopPoolId");
      Long var10 = (Long)var0.get("resourcePoolId");
      ResourcePool var11 = var5.queryResourcePoolById(var10);
      ArrayList var12 = new ArrayList();
      List var26;
      if((var26 = var7.queryProfileList(var11.getCloudId())) != null && var26.size() != 0) {
         if(var0.get("profileName") != null) {
            var12.add((String)var0.get("profileName"));
         } else {
            Iterator var27;
            if((var27 = var26.iterator()).hasNext()) {
               RpProfilePo var13 = (RpProfilePo)var27.next();
               var12.add(var13.getName());
            }
         }

         var19.addRestriction("orgId", var8);
         PublicCloud var28 = ResourcePoolUtils.getPublicCloudByResourcePoolId(var10, var5, var3);
         ArrayList var29 = new ArrayList();
         QueryResult var16;
         if((var16 = var5.queryResourcePoolNetByRsPoolId(var10)) != null && var16.getLength() > 0) {
            if(var0.get("vswitchName") != null) {
               var29.add((String)var0.get("vswitchName"));
            } else {
               Iterator var17 = var16.getData().iterator();

               while(var17.hasNext()) {
                  RpNet var21 = (RpNet)var17.next();
                  var29.add(var21.getName());
               }
            }

            String var18 = (String)var0.get("storagePoolName");
            Integer var22 = var11.getUseLocalStorageFlag();
            if(var9 != null || StringUtils.isNotBlank(var18)) {
               var22 = Integer.valueOf(0);
            }

            var0.set("useLocalStorageFlag", var22);
            List var20 = var6.checkOrgStorage(var0);
            var22 = var1.queryOrgById(var8).getMaxVmNum();
            String var23 = "SELECT COUNT( DISTINCT DOMAIN_ID) FROM TBL_USER_VM WHERE ORG_ID = " + var8;
            List var24 = var1.queryInfoBySql(var23);
            int var25 = 0;
            if(var24 != null && var24.size() > 0) {
               var25 = FuncUtil.getIntegerValue(var24.get(0)).intValue();
            }

            if(var25 >= var22.intValue()) {
               Object[] var15 = new Object[]{var22};
               throw new AppException(1507, var15);
            } else {
               if(var9 != null) {
                  var22 = var2.queryDesktopPoolById(var9).getMaxVmNum();
                  var23 = "SELECT COUNT( DISTINCT DOMAIN_ID) FROM TBL_USER_VM WHERE DESKTOP_POOL_ID = " + var9;
                  if((var24 = var1.queryInfoBySql(var23)) != null && var24.size() > 0) {
                     var25 = FuncUtil.getIntegerValue(var24.get(0)).intValue();
                  }

                  if(var25 >= var22.intValue()) {
                     Object[] var14 = new Object[]{var22};
                     throw new AppException(14050, var14);
                  }
               }

               var0.set("poolNames", var20);
               var0.set("vswitchNames", var29);
               var0.set("profileNames", var12);
               var0.set("publicCloudId", var28.getId());
            }
         } else {
            throw new AppException(603);
         }
      } else {
         throw new AppException(1126);
      }
   }

   public static void sendMailToUser(VmWorkflow var0, ModelData var1, User var2, StringManager var3, MailSenderMgr var4, SmsMgr var5) {
      try {
         String var6 = var3.getString("mail.vm.subject");
         Boolean var7 = (Boolean)var1.get("sysConfig");
         String var12 = var0.getTitle() == null?var0.getDomainName():var0.getTitle();
         String var8;
         if(var7 != null && var7.booleanValue()) {
            String var13 = "";
            if(((Integer)var1.get("sysIpType")).intValue() == 2) {
               var13 = var3.getString("ip.info", new Object[]{var1.get("sysIp")});
            }

            if((var8 = (String)var1.get("regOrGroup")) != null) {
               String var9 = var3.getString("region.domain", new Object[]{var8});
               if(var1.get("regOrGroupType") != null && ((Integer)var1.get("regOrGroupType")).intValue() == 2) {
                  var9 = var3.getString("region.workgroup", new Object[]{var8});
               }

               var12 = var3.getString("mail.vm.message", new Object[]{var2.getLoginName(), var12, var1.get("sysName"), var13, var9, var1.get("loginAccount"), var1.get("loginPassword")});
            } else {
               var12 = var3.getString("linux.mail.vm.message", new Object[]{var2.getLoginName(), var12, var1.get("sysName"), var13, var1.get("loginAccount"), var1.get("loginPassword")});
            }
         } else {
            var12 = var3.getString("mail.vm.no.sysconfig.message", new Object[]{var2.getLoginName(), var12});
         }

         if(StringUtils.isNotBlank(var2.getPhone()) && var5 != null) {
            try {
               if((var8 = (String)var5.readSmsConfig().get("smsBusinessView")) != null && var8.contains("1")) {
                  var5.sendSms(var2.getPhone(), var12);
               }
            } catch (Exception var10) {
               a.error((Object)null, var10);
            }
         }

         a.info("-------------------------message-------------------:" + var12);
         var4.sendMail(var2.getEmail(), var6, var12);
      } catch (Exception var11) {
         throw new AppException(1521);
      }
   }

   public static String getVmStatus(String var0) {
      if(var0.equals("unmanage")) {
         var0 = b.getString("virtStatusUnmanage");
      } else if(var0.equals("running")) {
         var0 = b.getString("virtStatusStart");
      } else if(var0.equals("paused")) {
         var0 = b.getString("virtStatusPause");
      } else if(var0.equals("notdeploy")) {
         var0 = b.getString("virtStatusNotDeploy");
      } else if(var0.equals("shutOff")) {
         var0 = b.getString("virtStatusShutoff");
      } else {
         var0 = b.getString("virtStatusUnknown");
      }

      return var0;
   }

   public static String getProgress(Object var0) {
      if(var0 != null) {
         double var1 = Double.parseDouble(var0.toString());
         return (var1 = Double.parseDouble((new DecimalFormat("#0.00")).format(var1))) > 100.0D?"100%":var1 + "%";
      } else {
         return "";
      }
   }

   public static String getMem(Long var0) {
      String var1 = "MB";
      double var2 = 0.0D;
      if(var0 != null) {
         if((var2 = Double.parseDouble(var0.toString())) >= 1048576.0D) {
            var2 = var2 / 1024.0D / 1024.0D;
            var1 = "TB";
         } else if(var2 >= 1024.0D) {
            var2 /= 1024.0D;
            var1 = "GB";
         }
      }

      String var4 = (new DecimalFormat("#0.00")).format(var2);
      return var4 + var1;
   }

   public static String getStorage(Double var0) {
      String var1 = "MB";
      double var2 = 0.0D;
      if(var0 != null) {
         if((var2 = Double.parseDouble(var0.toString())) >= 1048576.0D) {
            var2 = var2 / 1024.0D / 1024.0D;
            var1 = "TB";
         } else if(var2 >= 1024.0D) {
            var2 /= 1024.0D;
            var1 = "GB";
         }
      }

      String var4 = (new DecimalFormat("#0.00")).format(var2);
      return var4 + var1;
   }

   public static boolean getVmAssignMode(Long var0, Long var1, CommonMgr var2) {
      boolean var3 = false;
      StringBuilder var4;
      (var4 = new StringBuilder()).append("SELECT desktopPool.ASSIGN_MODE FROM TBL_USER_VM userVm,TBL_DESKTOP_POOL desktopPool ");
      var4.append("WHERE userVm.DOMAIN_ID=");
      var4.append(var0);
      var4.append(" AND userVm.PUBLIC_CLOUD_ID=");
      var4.append(var1);
      var4.append(" AND userVm.FLAG=0 ");
      var4.append(" AND userVm.USER_ID IS NULL AND userVm.USER_GROUP_ID IS NULL AND userVm.DESKTOP_POOL_ID IS NOT NULL ");
      var4.append(" AND userVm.DESKTOP_POOL_ID=desktopPool.ID;");
      List var5;
      if(!(var5 = var2.queryBySql(var4.toString())).isEmpty() && FuncUtil.getIntegerValue(var5.get(0)).intValue() == 2) {
         var3 = true;
      }

      return var3;
   }

   public static void orgDeployLimitCheck(Long var0, Integer var1, ModelData var2, PublicCloud var3, TemplateHandler var4, OrgParamertersHandler var5) {
      Long var6 = (Long)var2.get("id");
      RsDomain var7;
      if((var7 = var4.getTemplateByIdFromCvm(var3, var6)) == null) {
         throw new AppException(1000);
      } else {
         if(var1 == null) {
            var1 = Integer.valueOf(1);
         }

         Integer var9 = var7.getCpu();
         var6 = var7.getMemory();
         Long var8 = var7.getStorageCapacity();
         if(var2 != null) {
            if(var2.get("cpuCore") != null && var2.get("cpuSocket") != null) {
               var9 = Integer.valueOf(((Integer)var2.get("cpuCore")).intValue() * ((Integer)var2.get("cpuSocket")).intValue());
            }

            if(var2.get("memory") != null) {
               if(var2.get("memory") instanceof Long) {
                  var6 = (Long)var2.get("memory");
               } else {
                  var6 = Long.valueOf(((Integer)var2.get("memory")).longValue());
               }
            }
         }

         if(var9 != null) {
            var9 = Integer.valueOf(var9.intValue() * var1.intValue());
         }

         if(var6 != null) {
            var6 = Long.valueOf(var6.longValue() * (long)var1.intValue());
         }

         if(var8 != null) {
            var8 = Long.valueOf(var8.longValue() * (long)var1.intValue());
         }

         var5.checkOrgParamers(var0, var1, var9, var6, var8);
      }
   }

   public static void orgDeployLimitApply(Long var0, Integer var1, ModelData var2, PublicCloud var3, TemplateHandler var4, OrgParamertersHandler var5) {
      Long var6 = (Long)var2.get("id");
      RsDomain var7 = var4.getTemplateByIdFromCvm(var3, var6);
      if(var1 == null) {
         var1 = Integer.valueOf(1);
      }

      Integer var9 = var7.getCpu();
      var6 = var7.getMemory();
      Long var8 = var7.getStorageCapacity();
      if(var2 != null) {
         if(var2.get("cpuCore") != null && var2.get("cpuSocket") != null) {
            var9 = Integer.valueOf(((Integer)var2.get("cpuCore")).intValue() * ((Integer)var2.get("cpuSocket")).intValue());
         }

         if(var2.get("memory") != null) {
            if(var2.get("memory") instanceof Long) {
               var6 = (Long)var2.get("memory");
            } else {
               var6 = Long.valueOf(((Integer)var2.get("memory")).longValue());
            }
         }
      }

      if(var9 != null) {
         var9 = Integer.valueOf(var9.intValue() * var1.intValue());
      }

      if(var6 != null) {
         var6 = Long.valueOf(var6.longValue() * (long)var1.intValue());
      }

      if(var8 != null) {
         var8 = Long.valueOf(var8.longValue() * (long)var1.intValue());
      }

      var5.applyOrgResources(var0, var1, var9, var6, var8);
   }

   public static void orgDeployLimitRelease(Long var0, Integer var1, ModelData var2, PublicCloud var3, TemplateHandler var4, OrgParamertersHandler var5) {
      Long var6 = (Long)var2.get("id");
      RsDomain var7 = var4.getTemplateByIdFromCvm(var3, var6);
      if(var1 == null) {
         var1 = Integer.valueOf(1);
      }

      Integer var9 = var7.getCpu();
      var6 = var7.getMemory();
      Long var8 = var7.getStorageCapacity();
      if(var2 != null) {
         if(var2.get("cpuCore") != null && var2.get("cpuSocket") != null) {
            var9 = Integer.valueOf(((Integer)var2.get("cpuCore")).intValue() * ((Integer)var2.get("cpuSocket")).intValue());
         }

         if(var2.get("memory") != null) {
            var6 = Long.valueOf(((Integer)var2.get("memory")).longValue());
         }
      }

      if(var9 != null) {
         var9 = Integer.valueOf(var9.intValue() * var1.intValue());
      }

      if(var6 != null) {
         var6 = Long.valueOf(var6.longValue() * (long)var1.intValue());
      }

      if(var8 != null) {
         var8 = Long.valueOf(var8.longValue() * (long)var1.intValue());
      }

      var5.releaseOrgresources(var0, var1, var9, var6, var8);
   }

   public static void orgAddVmApply(Long var0, Long var1, OrgParamertersHandler var2, CommonMgr var3, HttpConnectionManager var4, DomainMgr var5, PublicCloudMgr var6) {
      int var7 = 0;
      long var8 = 0L;
      long var10 = 0L;
      QueryConfig var12;
      (var12 = new QueryConfig()).addRestriction("domainId", var1);
      var12.addRestriction("orgId", var0);
      QueryResult var21;
      if((var21 = var3.queryConfition(var12, UserVm.class)) == null || var21.getData() == null || var21.getData().size() <= 0) {
         PublicCloud var20;
         if((var20 = OrganizationUtils.getPublicCloudById(var5.queryDomainById(var1).getPublicCloudId(), var6)).getFlag().intValue() == 2) {
            RsDomainDetail var13;
            if((var13 = getDomainDetail(var1, var20, var4, var5)) != null) {
               CpuConfig var17;
               if((var17 = var13.getCpuConfig()) != null && var17.getCpuSockets() != null && var17.getCpuCores() != null) {
                  var7 = var17.getCpuSockets().intValue() * var17.getCpuCores().intValue();
               }

               if(var13.getMemory() != null && var13.getMemory().getSize() != null) {
                  var10 = var13.getMemory().getSize().longValue();
               }

               List var14;
               if((var14 = var13.getStorages()) != null) {
                  Iterator var15 = var14.iterator();

                  while(var15.hasNext()) {
                     StorageConfig var18;
                     if((var18 = (StorageConfig)var15.next()).getSize() != null && "disk".equals(var18.getDevice())) {
                        var8 += var18.getSize().longValue();
                     }
                  }
               }
            }
         } else if(var20.getFlag().intValue() == 3) {
            (var12 = new QueryConfig()).addRestriction("foreignId", var1);
            QueryResult var16;
            if((var16 = var3.queryConfition(var12, Domain.class)) != null && var16.getData() != null && var16.getData().size() > 0) {
               Domain var19;
               var7 = (var19 = (Domain)var16.getData().get(0)).getCpu().intValue();
               var10 = var19.getMemory().longValue();
               var8 = var19.getStorageCapacity().longValue();
            }
         }

         var2.checkOrgParamers(var0, Integer.valueOf(1), Integer.valueOf(var7), Long.valueOf(var10), Long.valueOf(var8));
         var2.applyOrgResources(var0, Integer.valueOf(1), Integer.valueOf(var7), Long.valueOf(var10), Long.valueOf(var8));
      }

   }

   public static RsDomainDetail getDomainDetail(Long var0, PublicCloud var1, HttpConnectionManager var2, DomainMgr var3) {
      String var4 = getUniqueKeyByDomainId(var0, var3);
      var4 = "/cas/casrs/vm/detail/" + var4;
      return (RsDomainDetail)RsClientUtils.queryCloudData(var2, var1, var4, RsDomainDetail.class);
   }

   public static void delOrgDomain(Long var0, OrgParamertersHandler var1, CommonMgr var2) {
      String var3 = "SELECT ID, ORG_ID FROM TBL_USER_VM WHERE DOMAIN_ID = " + var0;
      List var5 = var2.queryBySql(var3);
      delDomain(var0, var2);
      delDomainRela(var0, var2);
      if(var5 != null) {
         Iterator var4 = var5.iterator();

         while(var4.hasNext()) {
            var0 = FuncUtil.getLongValue(((Object[])var4.next())[1]);
            var1.updateOrgParamers(var0);
         }
      }

   }

   public static void vmChangeSyncOrgResource(Long var0, Long var1, Long var2, DomainHandler var3, OrgParamertersHandler var4) {
      var3.syncVmFromPublicCloud(var0, var1);
      var4.updateOrgParamers(var2);
   }

   public static void checkOrgVmChange(Long var0, Long var1, Integer var2, Integer var3, Long var4, Long var5, OrgParamertersHandler var6, CommonMgr var7) {
      String var8 = "SELECT ID, ORG_ID FROM TBL_USER_VM WHERE DOMAIN_ID = " + var0 + " AND  PUBLIC_CLOUD_ID=" + var1;
      List var9;
      if((var9 = var7.queryBySql(var8)) != null) {
         Iterator var10 = var9.iterator();

         while(var10.hasNext()) {
            var0 = FuncUtil.getLongValue(((Object[])var10.next())[1]);
            var6.checkOrgParamers(var0, var2, var3, var4, var5);
         }
      }

   }

   public static void modifyOrgVm(RsDomainForModify var0, Long var1, OrgParamertersHandler var2, OrganizationMgr var3, PublicCloudMgr var4, HttpConnectionManager var5, DomainMgr var6) {
      int var7 = 0;
      long var8 = 0L;
      long var10 = 0L;
      if(var0 != null) {
         Long var12 = var0.getId();
         QueryConfig var13;
         (var13 = new QueryConfig()).addRestriction("domainId", var12);
         var13.addRestriction("publicCloudId", var1);
         QueryResult var32;
         if((var32 = var3.queryUserVmByCondition(var13)) != null && var32.getData() != null && var32.getData().size() > 0) {
            var1 = ((UserVm)var32.getData().get(0)).getOrgId();
            PublicCloud var34;
            RsDomainDetail var35;
            if((var34 = OrganizationUtils.getPublicCloudById(var6.queryDomainById(var12).getPublicCloudId(), var4)).getFlag().intValue() == 2 && (var35 = getDomainDetail(var12, var34, var5, var6)) != null) {
               CpuConfig var36 = var0.getCpuConfig();
               CpuConfig var37 = var35.getCpuConfig();
               if(var36 != null && var36.getCpuSockets() != null && var36.getCpuCores() != null && var37 != null && var37.getCpuSockets() != null && var37.getCpuCores() != null) {
                  int var21 = var36.getCpuSockets().intValue() * var36.getCpuCores().intValue();
                  int var22 = var37.getCpuSockets().intValue() * var37.getCpuCores().intValue();
                  var7 = var21 - var22;
               }

               if(var0.getMemory() != null && var0.getMemory().getSize() != null && var35.getMemory() != null && var35.getMemory().getSize() != null) {
                  long var29 = var0.getMemory().getSize().longValue();
                  long var23 = var35.getMemory().getSize().longValue();
                  var8 = var29 - var23;
               }

               StorageConfig var30 = var0.getStorage();
               List var31 = var35.getStorages();
               if(var30 != null && var31 != null) {
                  Iterator var33 = var31.iterator();

                  while(var33.hasNext()) {
                     StorageConfig var24 = (StorageConfig)var33.next();
                     if("disk".equals(var24.getDevice()) && var24.getDeviceName().equals(var30.getDeviceName())) {
                        long var25 = var24.getSize().longValue();
                        var10 = var30.getSize().longValue() - var25;
                        break;
                     }
                  }
               }
            }

            var2.checkOrgParamers(var1, Integer.valueOf(0), Integer.valueOf(var7), Long.valueOf(var8), Long.valueOf(var10));
            var2.applyOrgResources(var1, Integer.valueOf(0), Integer.valueOf(var7), Long.valueOf(var8), Long.valueOf(var10));
         }
      }

   }

   public static void updateVmWorkFlowStatus(VmWorkflowMgr var0, Long var1, Integer var2, String var3) {
      if(var1 != null) {
         try {
            VmWorkflow var5;
            (var5 = var0.queryVmWorkflowById(var1)).setStatus(var2);
            var5.setHandleReason(var3);
            var0.updateVmWorkflow(var5);
            return;
         } catch (AppException var4) {
            a.error((Object)null, var4);
         }
      }

   }

   private static List a(Long var0, Long var1, CommonMgr var2) {
      StringBuilder var3;
      (var3 = new StringBuilder()).append("SELECT ID,UNIQUE_KEY from TBL_DOMAIN WHERE PUBLIC_CLOUD_ID = ").append(var0);
      if(var1.longValue() == 2L) {
         var3.append(" AND ENABLE = 2");
      } else {
         var3.append(" AND ENABLE = 1");
      }

      return var2.queryBySql(var3.toString());
   }

   public static HashMap getIDAndUniqueKeyPairMap(Long var0, CommonMgr var1) {
      HashMap var2 = new HashMap();
      List var3;
      if(!(var3 = a(var0, Long.valueOf(1L), var1)).isEmpty()) {
         Iterator var4 = var3.iterator();

         while(var4.hasNext()) {
            Object[] var5 = (Object[])var4.next();
            var2.put(FuncUtil.getLongValue(var5[0]), (String)var5[1]);
         }
      }

      return var2;
   }

   public static HashMap getUniqueKeyAndIDPairMap(Long var0, CommonMgr var1) {
      HashMap var2 = new HashMap();
      List var3;
      if(!(var3 = a(var0, Long.valueOf(1L), var1)).isEmpty()) {
         Iterator var4 = var3.iterator();

         while(var4.hasNext()) {
            Object[] var5 = (Object[])var4.next();
            var2.put((String)var5[1], FuncUtil.getLongValue(var5[0]));
         }
      }

      return var2;
   }

   public static HashMap getUniqueKeyAndIDPairMap(Long var0, Long var1, CommonMgr var2) {
      HashMap var3 = new HashMap();
      Iterator var4 = a(var0, var1, var2).iterator();

      while(var4.hasNext()) {
         Object[] var5 = (Object[])var4.next();
         var3.put((String)var5[1], FuncUtil.getLongValue(var5[0]));
      }

      return var3;
   }

   public static void saveOrUpdateDomain(DomainMgr var0, HostMgr var1, Domain var2, Long var3, String var4) {
      try {
         Domain var6;
         if((var6 = var0.queryDomainByKeyAndCloudIdWithoutException(var4, var3.longValue())) == null) {
            var0.addDomain(var2);
         } else {
            var2.setId(var6.getId());
            var2.setCloudType(var6.getCloudType());
            var2.setPublicCloudId(var6.getPublicCloudId());
            var2.setHostId(var6.getHostId());
            var2.setHostPoolId(var6.getHostPoolId());
            var2.setClusterId(var6.getClusterId());
            var0.updateDomain(var2);
         }
      } catch (Exception var5) {
         a.error(var5);
         throw new AppException(11);
      }
   }

   public static void setDomainParentsId(HostMgr var0, Domain var1, String var2, Long var3) {
      try {
         Host var5;
         if((var5 = var0.queryHostByUniqueKeyAndCloudId(var2, var3.longValue())) != null) {
            var1.setHostId(var5.getId());
            var1.setClusterId(var5.getClusterId());
            var1.setHostPoolId(var5.getHostpoolId());
         }

      } catch (Exception var4) {
         ;
      }
   }

   public static String getUniqueKeyByDomainId(Long var0, DomainMgr var1) {
      Domain var2 = var1.queryDomainByIdNoException(var0);
      String var3 = "0";
      if(var2 != null) {
         var3 = var2.getUniqueKey();
      }

      return var3;
   }

   public static String getUniqueKeyListByIds(List var0, DomainMgr var1) {
      String var2 = "-1";
      StringBuilder var3 = new StringBuilder();
      QueryConfig var4;
      (var4 = new QueryConfig()).addRestriction("idList", var0);
      QueryResult var5;
      if(!CollectionUtils.isEmpty((var5 = var1.queryDomainsByCondition(var4)).getData())) {
         Iterator var6 = var5.getData().iterator();

         while(var6.hasNext()) {
            Domain var7 = (Domain)var6.next();
            var3.append(var7.getUniqueKey()).append(",");
         }
      }

      if(var3.length() > 0) {
         var2 = var3.substring(0, var3.length() - 1);
      }

      return var2;
   }

   public static List getUniqueKeyListByIds(Long var0, List var1, DomainMgr var2) {
      ArrayList var3 = new ArrayList();
      QueryConfig var4;
      (var4 = new QueryConfig()).addRestriction("idList", var1);
      var4.addRestriction("cloudId", var0);
      QueryResult var5;
      if(!CollectionUtils.isEmpty((var5 = var2.queryDomainsByCondition(var4)).getData())) {
         Iterator var6 = var5.getData().iterator();

         while(var6.hasNext()) {
            Domain var7 = (Domain)var6.next();
            var3.add(FuncUtil.getLongValue(var7.getUniqueKey()));
         }
      }

      return var3;
   }

   public static DomainStatusCount countDomainStatusInfo(long var0, int var2, DomainMgr var3) {
      QueryConfig var4 = new QueryConfig();
      if(var2 == 20) {
         var4.addRestriction("hostPoolId", Long.valueOf(var0));
      } else if(var2 == 22) {
         var4.addRestriction("clusterId", Long.valueOf(var0));
      } else if(var2 == 21) {
         var4.addRestriction("hostId", Long.valueOf(var0));
      } else {
         var4.addRestriction("cloudId", Long.valueOf(var0));
      }

      QueryResult var5;
      if((var5 = var3.queryDomainsByCondition(var4)).getData() == null) {
         return new DomainStatusCount();
      } else {
         int var1 = var5.getData().size();
         var2 = 0;
         int var8 = 0;
         Iterator var6 = var5.getData().iterator();

         while(var6.hasNext()) {
            Domain var9 = (Domain)var6.next();
            if(!"running".equals(var9.getStatus()) && !"paused".equals(var9.getStatus())) {
               if("shutOff".equals(var9.getStatus()) || "shutdown".equals(var9.getStatus())) {
                  ++var8;
               }
            } else {
               ++var2;
            }
         }

         DomainStatusCount var7;
         (var7 = new DomainStatusCount()).setVmTotal(var1);
         var7.setRunningTotal(var2);
         var7.setOffTotal(var8);
         return var7;
      }
   }

   public static void syncTemplateFromPublicCloud(String var0, PublicCloud var1, HttpConnectionManager var2, DomainMgr var3) {
      String var4 = "/cas/casrs/vmTemplate/vmTemplateInfo?id=" + var0;
      RsDomain var7 = (RsDomain)RsClientUtils.queryCloudData(var2, var1, var4, RsDomain.class);
      Domain var8;
      (var8 = new Domain()).setForeignId(var7.getId());
      var8.setUniqueKey(var0);
      var8.setPublicCloudId(var1.getId());
      var8.setDomainName(var7.getName());
      var8.setTitle(var7.getTitle());
      var8.setDescription(var7.getDescription());
      int var5 = var7.getCpuCores() == null?0:var7.getCpuCores().intValue();
      int var6 = var7.getCpuSockets() == null?0:var7.getCpuSockets().intValue();
      var8.setCpu(Integer.valueOf(var5 * var6));
      var8.setMemory(var7.getMemory());
      var8.setUuid("");
      var8.setSystem(var7.getSystem());
      var8.setEnable(Integer.valueOf(2));
      var8.setStorageCapacity(var7.getStorageCapacity());
      var8.setCloudType(Integer.valueOf(2));
      var8.setCreateDate(var7.getCreateDate());
      var3.addDomain(var8);
   }

   public static Map getDomainIdAndHostNameMap(List var0, DomainMgr var1) {
      HashMap var2 = new HashMap();

      try {
         ArrayList var3 = new ArrayList();
         Iterator var6 = var0.iterator();

         while(var6.hasNext()) {
            Domain var4 = (Domain)var6.next();
            var3.add(var4.getUniqueKey());
         }

         if(!var3.isEmpty() && (var0 = var1.queryVmIdAndHostNameMapByUniqueKeyList(var3)) != null) {
            Iterator var10 = var0.iterator();

            while(var10.hasNext()) {
               Object[] var7;
               Long var8 = (Long)(var7 = (Object[])var10.next())[0];
               String var9 = (String)var7[1];
               var2.put(var8, var9);
            }
         }
      } catch (Exception var5) {
         a.error(var5);
      }

      return var2;
   }

}
